/**************************************************************************/
/*                                                                        */
/*             'Hu-Go! Compact disk Definition' handling code             */
/*                                                                        */
/* This is 'copyleft'. Use and abuse it as you want.                      */
/*                                                                        */
/**************************************************************************/

#include "hcd.h"

UInt32 HCD_first_track;

UInt32 HCD_last_track;

char HCD_cover_filename[256] = "";

FILE *HCD_iso_FILE = 0;

PACKFILE *HCD_packed_iso_FILE = 0;

UInt32 HCD_current_subtitle = 0;

UInt32 HCD_frame_at_beginning_of_track = 0;

UChar HCD_current_played_track = 0;



int
fill_HCD_info (char *name)
{
  int current_track;

  char *MP3_path, *ISO_path;

  char MP3_path_tmp[256], ISO_path_tmp[256];

  set_config_file (name);

  HCD_first_track = get_config_int ("main", "first_track", 1);

  HCD_last_track = get_config_int ("main", "last_track", 22);

  current_track = get_config_int ("main", "minimum_bios", -1);

  MP3_path = get_config_string ("main", "MP3_path", "");

  if (!strcmp (MP3_path, ""))
    {

      fix_filename_path (MP3_path_tmp, name, 256);

      {
	int i;
	for (i = 0; MP3_path_tmp[i]; i++)
	  if (MP3_path_tmp[i] == '\\')
	    MP3_path_tmp[i] = '/';

      }

      if (strrchr (MP3_path_tmp, '/'))
	*(strrchr (MP3_path_tmp, '/') + 1) = 0;

      MP3_path = MP3_path_tmp;

    }


  ISO_path = get_config_string ("main", "ISO_path", "");


  if (!strcmp (ISO_path, ""))
    {

      fix_filename_path (ISO_path_tmp, name, 256);

      {
	int i;
	for (i = 0; ISO_path_tmp[i]; i++)
	  if (ISO_path_tmp[i] == '\\')
	    ISO_path_tmp[i] = '/';

      }

      if (strrchr (ISO_path_tmp, '/'))
	*(strrchr (ISO_path_tmp, '/') + 1) = 0;

      ISO_path = ISO_path_tmp;

    }

  if (current_track != -1)
    minimum_bios_hooking = current_track;

  for (current_track = HCD_first_track;
       current_track <= HCD_last_track; current_track++)
    {
      char *section_name = (char *) alloca (100);
      char *tmp_buf = (char *) alloca (100);

      sprintf (section_name, "track%d", current_track);

      //----- Init patch section -----

      CD_track[current_track].patch_number = 0;

      CD_track[current_track].patch = NULL;

      //----- find beginning ---------

      strcpy (tmp_buf,
	      strupr (get_config_string (section_name, "begin", "")));

      if (strcasestr (tmp_buf, "MSF"))
	{

	  int min = (tmp_buf[4] - '0') * 10 + (tmp_buf[5] - '0');
	  int sec = (tmp_buf[7] - '0') * 10 + (tmp_buf[8] - '0');
	  int fra = (tmp_buf[10] - '0') * 10 + (tmp_buf[11] - '0');

	  CD_track[current_track].beg_lsn = fra + 75 * (sec + 60 * min);

	  CD_track[current_track].beg_lsn -= 150;

	}
      else if (strcasestr (tmp_buf, "LSN"))
	{

	  CD_track[current_track].beg_lsn = atoi (&tmp_buf[4]) - 150;

	}
      else if (strcasestr (tmp_buf, "LBA"))
	{

	  CD_track[current_track].beg_lsn = atoi (&tmp_buf[4]);

	}
      else
	CD_track[current_track].beg_lsn = 0;

      //----- determine type ---------

      strcpy (tmp_buf,
	      strupr (get_config_string (section_name, "type", "AUDIO")));

      Log ("read type %p\n", tmp_buf);

      if (strcmp (tmp_buf, "CODE") == 0)
	{

	  //----- track is code ---------

	  CD_track[current_track].type = 4;	// Code track

	  //----- search filename of ISO ---------

	  strcpy (tmp_buf, ISO_path);

	  strcat (tmp_buf, get_config_string (section_name, "filename", ""));

	  strcpy (CD_track[current_track].filename, tmp_buf);

	  if (!exists (tmp_buf))
	    {
	      Log ("Missing ISO file : %s\nUsed to emulate track %d.",
		   tmp_buf, current_track);
	      return 0;
	    }

	  //----- determine file length of track ---------

	  CD_track[current_track].length = file_size (tmp_buf) / 2048;

	  //----- search for patch -----------------------

	  CD_track[current_track].patch_number =
	    get_config_int (section_name, "patch_number", 0);

	  if (CD_track[current_track].patch_number)
	    {
	      UInt32 i;
	      char tmp_str[256];

	      CD_track[current_track].patch =
		(PatchEntry *) malloc (sizeof (PatchEntry)
				       *
				       CD_track[current_track].patch_number);

	      for (i = 0; i < CD_track[current_track].patch_number; i++)
		{

		  sprintf (tmp_str, "patch%d", i);

		  strcpy (tmp_str, get_config_string (section_name,
						      tmp_str,
						      "0XFFFFFFFF,0XFF"));

		  sscanf (tmp_str, "%X,%X",
			  &CD_track[current_track].patch[i].offset,
			  &CD_track[current_track].patch[i].new_val);

		  Log
		    ("Patch #%d makes bytes at offset 0x%X replaced by 0x%X\n",
		     i, CD_track[current_track].patch[i].offset,
		     CD_track[current_track].patch[i].new_val);


		}
	    }

	}
      else
	{

	  //----- track is audio ---------

	  CD_track[current_track].type = 0;	// Audio track

	  //----- search filename ---------

	  strcpy (tmp_buf, MP3_path);

	  strcat (tmp_buf, get_config_string (section_name, "filename", ""));

	  strcpy (CD_track[current_track].filename, tmp_buf);

	  //----- search for subtitles -----------------------

	  CD_track[current_track].subtitle_synchro_type =
	    get_config_int (section_name, "synchro_mode", 0);

	  CD_track[current_track].subtitle_number =
	    get_config_int (section_name, "subtitle_number", 0);

	  if (CD_track[current_track].subtitle_number)
	    {
	      UInt32 i;
	      char tmp_str[256];

	      CD_track[current_track].subtitle =
		(SubtitleEntry *) malloc (sizeof (SubtitleEntry)
					  *
					  CD_track[current_track].
					  subtitle_number);

	      for (i = 0; i < CD_track[current_track].subtitle_number; i++)
		{

		  sprintf (tmp_str, "subtitle%d", i);

		  strcpy (tmp_str, get_config_string (section_name,
						      tmp_str, "0,0,"));

		  sscanf (tmp_str, "%d,%d",
			  &CD_track[current_track].subtitle[i].StartTime,
			  &CD_track[current_track].subtitle[i].Duration);

		  if (strrchr (tmp_str, ','))
		    {
		      memset (CD_track[current_track].subtitle[i].data, 0,
			      32);
		      strncpy (CD_track[current_track].subtitle[i].data,
			       strrchr (tmp_str, ',') + 1, 31);
		    }

		  Log
		    ("Subtitle #%d begins at %d, lasts %d 60th of sec and is %s\n",
		     i, CD_track[current_track].subtitle[i].StartTime,
		     CD_track[current_track].subtitle[i].Duration,
		     CD_track[current_track].subtitle[i].data);

		}
	    }


	  //----- use Tormod's work to guess MP3 length ---------

	  CD_track[current_track].length =
	    (int) (MP3_length (CD_track[current_track].filename) * 75.0);

	  Log ("After MP3 length guessing, size of %s is %d 75th of second\n",
	       CD_track[current_track].filename,
	       CD_track[current_track].length);

	  if (CD_track[current_track].length == 0)
	    CD_track[current_track].length = 30 * 75;	// 30 sec track

	}

      //----- if begin hasn't been specified ---------

      if (!CD_track[current_track].beg_lsn)
	{
	  if (current_track == 1)
	    CD_track[current_track].beg_lsn = 0;
	  else
	    CD_track[current_track].beg_lsn =
	      CD_track[current_track - 1].beg_lsn +
	      CD_track[current_track - 1].length;
	}

      //----- convert beginning in PCE msf format ---------

      {
	int min, sec, fra;

	Frame2Time (CD_track[current_track].beg_lsn + 150, &min, &sec, &fra);

	CD_track[current_track].beg_min = binbcd[min];
	CD_track[current_track].beg_sec = binbcd[sec];
	CD_track[current_track].beg_fra = binbcd[fra];
      }
    }

  return 1;

}

void
HCD_pause_playing ()
{

  if (MP3_playing)
    MP3_playing = 0;

};

void
HCD_play_track (int track, char repeat)
{

  switch (CD_track[track].subtitle_synchro_type)
    {
    case 0:			// frame synchronisation
      HCD_frame_at_beginning_of_track = frame;
      break;
    case 1:			// timer synchronisation
      HCD_frame_at_beginning_of_track = timer_60;
      break;
    default:
    }

  HCD_current_played_track = track;
  HCD_current_subtitle = 0;

  if (strcasestr (CD_track[track].filename, ".MP3"))
    {				// must play MP3
      load_amp (CD_track[track].filename, repeat);
      MP3_playing = 1;
    }

};

void
HCD_play_sectors (int begin_sect, int sect_len, char repeat)
{

  int result;

  for (result = nb_max_track; result; result--)
    {
      if ((begin_sect >= CD_track[result].beg_lsn) &&
	  (begin_sect <= CD_track[result].beg_lsn + CD_track[result].length))
	break;
    }


  if (strcasestr (CD_track[result].filename, ".MP3"))
    {				// must play MP3

      if (-150 < begin_sect - CD_track[result].beg_lsn < 150)
	load_amp (CD_track[result].filename, repeat);
      else			/* can't yet easily repeat "inside" a track */
	load_amp (CD_track[result].filename, FALSE);

      if (amp_pollsize)
	seek_amp_abs (amp_samprat / amp_pollsize *
		      (begin_sect - CD_track[result].beg_lsn) / 75);

      HCD_frame_at_beginning_of_track =
	frame - (begin_sect - CD_track[result].beg_lsn) / 75.0 * 60.0;
      /* try to estimate the number of cycle that should have elapsed since
         the beginning of the track */

      HCD_current_played_track = result;
      HCD_current_subtitle = 0;

      MP3_playing = 1;


    }
  else if (strcasestr (CD_track[result].filename, ".WAV"))
    {
#ifndef LINUX

      static SAMPLE *wav_sample;

      wav_sample = load_sample (CD_track[result].filename);

      play_sample (wav_sample, 255, 128, 1000, FALSE);

#endif

    }

};

void
HCD_shutdown ()
{
  int current_track;

  for (current_track = HCD_first_track;
       current_track <= HCD_last_track; current_track++)
    {
      free (CD_track[current_track].patch);
      free (CD_track[current_track].subtitle);
    }

};

void
HCD_handle_subtitle ()
{

  if (HCD_current_subtitle >=
      CD_track[HCD_current_played_track].subtitle_number)
    return;

  switch (CD_track[HCD_current_played_track].subtitle_synchro_type)
    {
    case 0:
      if (frame - HCD_frame_at_beginning_of_track >=
	  CD_track[HCD_current_played_track].subtitle[HCD_current_subtitle].
	  StartTime)
	{
	  osd_gfx_set_message (CD_track[HCD_current_played_track].
			       subtitle[HCD_current_subtitle].data);
	  message_delay =
	    CD_track[HCD_current_played_track].subtitle[HCD_current_subtitle].
	    Duration;
	  HCD_current_subtitle++;
	}
      break;
    case 1:
      if (timer_60 - HCD_frame_at_beginning_of_track >=
	  CD_track[HCD_current_played_track].subtitle[HCD_current_subtitle].
	  StartTime)
	{
	  osd_gfx_set_message (CD_track[HCD_current_played_track].
			       subtitle[HCD_current_subtitle].data);
	  message_delay =
	    CD_track[HCD_current_played_track].subtitle[HCD_current_subtitle].
	    Duration;
	  HCD_current_subtitle++;
	}
      break;

    default:
    }

}
